# $Revision: 1.61 $, $Date: 2011/09/01 17:04:37 $
# TODO:
# - review alpha patch
#
# Conditional build:
%bcond_with	tests	# run test suite `make check' (uses network, won't pass on vserver)
#
Summary:	Common Lisp (ANSI CL) implementation
Summary(pl.UTF-8):	Implementacja Common Lisp (ANSI CL)
Summary(pt_BR.UTF-8):	Implementação do Common Lisp (ANSI CL)
Name:		clisp
Version:	2.47
Release:	7
License:	GPL
Group:		Development/Languages
Source0:	http://dl.sourceforge.net/clisp/%{name}-%{version}.tar.bz2
# Source0-md5:	8fa89bb13e865fc7c7150b82682f35af
Patch0:		%{name}-shell.patch
Patch1:		%{name}-alpha.patch
Patch2:		%{name}-gcc4.patch
URL:		http://clisp.cons.org/
BuildRequires:	ffcall-devel
BuildRequires:	gettext-devel
BuildRequires:	libsigsegv >= 2.4
BuildRequires:	ncurses-devel
BuildRequires:	readline-devel
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXpm-devel
BuildRequires:	xorg-proto-xextproto-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define specflags_ppc	-DNO_GENERATIONAL_GC
%define specflags_ppc64	-DNO_GENERATIONAL_GC

%description
Common Lisp is a high-level, all-purpose programming language. CLISP
is a Common Lisp implementation by Bruno Haible of Karlsruhe
University and Michael Stoll of Munich University, both in Germany. It
mostly supports Common Lisp as described in the ANSI CL standard. It
runs on microcomputers (DOS, OS/2, Windows NT, Windows 95, Amiga
500-4000, Acorn RISC PC) as well as on Unix workstations (Linux, SVR4,
Sun4, DEC Alpha OSF, HP-UX, NeXTstep, SGI, AIX, Sun3 and others) and
needs only 2 MB of RAM.

It is free software and may be distributed under the terms of GNU GPL,
while it is possible to distribute commercial applications compiled
with CLISP.

The user interface comes in German, English, French and Spanish. CLISP
includes an interpreter, a compiler, a large subset of CLOS, a foreign
language interface and a socket interface. An X11 interface is
available through CLX and Garnet.

%description -l pl.UTF-8
Common Lisp to wysokopoziomowy język programowania ogólnego
przeznaczenia. CLISP to implementacja Common Lisp, której autorami są
Bruno Haible z Karlsruhe University oraz Michael Stoll z Munich
University (oba w Niemczech). W większości wspiera Common Lisp opisany
w standardzie ANSI CL. Działa na mikrokomputerach (DOS, OS/2, Windows
NT, Windows 95, Amiga 500-4000, Acorn RICS PC), a także stacjach
uniksowych (Linux, SVR4, Sun4, DEC Alpha OSF, HP-UX, NeXTstep, SGI,
AIX, Sun3 i inne) i wymaga tylko 2 MB RAM.

To jest oprogramowanie wolnodostępne, na licencji GNU GPL, możliwe
jest dystrybuowanie komercyjnych aplikacji skompilowanych CLISP-em.

Interfejs użytkownika dostępny jest po niemiecku, angielsku, francusku
i hiszpańsku. CLISP zawiera interpreter, kompilator, znaczny podzbiór
CLOS, interfejs do innych języków oraz interfejs do gniazdek.
Interfejs X11 jest dostępny poprzez CLX i Garnet.

%description -l pt_BR.UTF-8
Common Lisp é uma linguagem de programação de propósito geral de alto
nível. CLISP é uma implementação do Common Lisp feita por Bruno
Haible, da Universidade Karlsruhe, e Michael Stoll, da Universidade de
Munique, ambas na Alemanha. O CLISP é quase totalmente compatível com
o Common Lisp descrito pelo padrão ANSI CL. Além disso, CLISP é
software livre, distribuído sob os termos da GNU GPL.

%prep
%setup -q
%patch0 -p1
#%patch1 -p1
%patch2 -p1

# changing default -O to optflags causes memory fault on amd64
# - so something is broken... code or compiler
# -fno-strict-aliasing seems to fix crashes on amd64 but doesn't fix
# random crashes on sparc (which occur with default CFLAGS)
#%{__perl} -pi -e "s@' -O2?([^0])@' %{rpmcflags} -fno-strict-aliasing\$1@" src/makemake.in

%build

%ifarch ppc ppc64
ulimit -s unlimited
%else
ulimit -s 32768
%endif

CC="%{__cc}" \
%ifarch sparc sparcv9 sparc64
CFLAGS="%{rpmcflags} -DSAFETY=3" \
%else
CFLAGS="%{rpmcflags}" \
%endif
./configure \
	--prefix=%{_prefix}

cd src
./makemake \
	--prefix=%{_prefix} \
	--with-readline \
	--with-gettext \
	--with-dynamic-ffi \
	--fsstnd=redhat \
	--with-module=wildcard \
	--with-module=bindings/glibc \
	--with-module=clx/new-clx \
	>Makefile
%{__make} -j1 config.lisp \
	TOPDIR=clisp
%{__make} -j1 \
	libdir=%{_libdir} \
	TOPDIR=clisp

%{?with_tests:%{__make} -j1 check}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -j1 -C src install \
	DESTDIR=$RPM_BUILD_ROOT \
	libdir=%{_libdir} \
	lispdocdir=%{_docdir}/%{name}-%{version} \
	mandir=%{_mandir} \
	TOPDIR=clisp

install -d $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/modules
install modules/*/*.dvi $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/modules

%find_lang %{name} --all-name

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/clisp
%doc %{_docdir}/%{name}-%{version} 
%dir %{_libdir}/clisp
%dir %{_libdir}/clisp/base
%{_libdir}/clisp/base/*.[aho]
%{_libdir}/clisp/base/lispinit.mem
%attr(755,root,root) %{_libdir}/clisp/base/lisp.run
%{_libdir}/clisp/base/makevars
%{_libdir}/clisp/clisp-link
%{_libdir}/clisp/data
%dir %{_libdir}/clisp/full
%attr(755,root,root) %{_libdir}/clisp/full/lisp.run
%{_libdir}/clisp/full/*.[aho]
%{_libdir}/clisp/full/lispinit.mem
%{_libdir}/clisp/full/makevars
%{_libdir}/clisp/linkkit
%{_mandir}/man[13]/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: clisp.spec,v $
Revision 1.61  2011/09/01 17:04:37  arekm
- release 7

Revision 1.60  2009/06/30 11:05:12  tommat
- try to build on sparcs

Revision 1.59  2009/06/30 09:04:22  tommat
- fix building on new gcc

Revision 1.58  2009/05/03 22:47:45  hawk
- release 6

Revision 1.57  2009/04/10 19:47:30  sparky
- works on ppc (forge actually), rel 5

Revision 1.56  2009/04/10 19:35:01  sparky
- ulimit -s unlimited on ppc - stack size of about 8Mb is required to build
  this of forge

Revision 1.55  2009/04/10 16:56:53  sparky
- actually enable the ppc hack

Revision 1.54  2009/03/21 20:48:08  pawelz
- rel 4 (now it builds on ppc too)

Revision 1.53  2009/03/21 20:16:44  pawelz
- ppc hack stolen from mandriva
- not tested, I have no access to ppc machine

Revision 1.52  2009/03/05 23:05:51  baggins
- rel 3

Revision 1.51  2009/03/05 22:57:49  baggins
- paralled build isn't?

Revision 1.50  2009/03/05 22:32:45  baggins
- rel 2

Revision 1.49  2009/02/18 21:31:59  duddits
- forgot to clean %doc

Revision 1.48  2009/02/18 15:52:03  duddits
- up to 2.47

Revision 1.47  2008/06/20 16:04:46  lkrotowski
- up to 2.45

Revision 1.46  2007/02/12 21:23:51  glen
- tabs in preamble

Revision 1.45  2007/02/12 00:48:42  baggins
- converted to UTF-8

Revision 1.44  2006/11/07 20:02:38  qboosh
- disable tests by default
  (some uses remote http:, another one fails when there is no lo interface
  (e.g. in vserver))

Revision 1.43  2006/11/01 21:01:12  twittner
- oops - clisp has been already build with rel. 1
  and auto-th-.. tag exists - rel. 2

Revision 1.42  2006/11/01 20:38:47  twittner
- back to rel. 1 (passed tests on all Th builders but i686 - blame
  builder for it not clisp)

Revision 1.41  2006/11/01 16:27:08  qboosh
- tabs

Revision 1.40  2006/11/01 14:40:20  twittner
- missing BR: xorg-lib-libXpm-devel added
- socket tests passed on my computer (it failed on th-i686 builder
  - builder local configuration issue?)
- uses outside connection during building:
  ;; connecting to "http://clisp.cons.org/impnotes/id-href.map"...connected...HTTP/1.1 200 OK...65,830 bytes
- lang files listed twice (dunno why)
- rel. 0.2, works

Revision 1.39  2006/11/01 12:56:29  twittner
- rel. 0.1 (downgrade) - it builds on Ac but doesn't pass tests
  on builder Th  - I have no way for viewing
  /home/users/builder/rpm/BUILD/clisp-2.41/src/tests/*.erg
- added BRs xorg-lib-libX11-devel and xorg-proto-xextproto-devel (based on
  clisp-2.41/modules/clx/new-clx/clx.f #includes) - but still raises:
  "
  checking for X... (cached) no
  configure: error: cannot find X Window System
  "
  on my computer.

Revision 1.38  2006/10/30 20:03:03  twittner
- up to 2.41

Revision 1.37  2006/07/17 18:57:00  qrczak
- Updated to 2.39
- Release notes say: libsigsegv >= 2.4

Revision 1.36  2006/02/28 23:37:25  glen
- adapterized (killed trailing spaces/tabs)

Revision 1.35  2006/01/21 00:01:16  arekm
- kill Icon: field (support for these is obsolete says jbj)

Revision 1.34  2006/01/08 20:32:41  qboosh
- unified

Revision 1.33  2006/01/08 15:46:19  twittner
- up to 2.37
- added bcond tests (default on), run test suite (passed without errors on
  my computer)
- pass compiler through `CC'

Revision 1.32  2005/12/05 12:28:31  undefine
- up to 2.36
- remove system(built by default) modules
- BR: libsegsev

Revision 1.31  2005/10/10 12:19:43  qboosh
- added alpha patch

Revision 1.30  2005/10/08 18:52:50  arekm
- up to 2.35

Revision 1.29  2005/09/17 10:54:14  arekm
- readline 5.0

Revision 1.28  2005/07/26 01:44:25  undefine
- up to 2.34

Revision 1.27  2004/06/14 13:36:26  undefine
- update to 2.33.2

Revision 1.26  2004/06/01 17:28:21  qboosh
- more optflags comments... something is heavily broken

Revision 1.25  2004/05/31 19:23:42  qboosh
- added typecodes patch (fixes build on amd64 and probably alpha)
- lib64 fix, missing dir, release 2

Revision 1.24  2004/05/28 19:50:27  undefine
- update to 2.33.1

Revision 1.23  2004/03/23 22:50:42  undefine
- update to 2.33

Revision 1.22  2004/01/01 18:11:16  undefine
- manual add changelod to prev entry:
- version 0.32, remove outdated patches, release 1, manually added changelog

Revision 1.21  2004/01/01 17:59:11  undefine
- version 0.32, remove outdated patches, release 1, manually added changelog

Revision 1.20  2003/12/04 12:32:35  undefine
- merge patches from http://atrpms.physik.fu-berlin.de/dist/rh9/clisp/

Revision 1.19  2003/12/04 06:53:22  undefine
- update to 2.31

Revision 1.18  2003/12/01 00:22:13  undefine
- release 2 to rebuild with ac

Revision 1.17  2003/11/11 00:41:48  witekfl
- s/linuxlibc6/glibc/

Revision 1.16  2003/08/06 16:47:31  kloczek
- może wrescie ktoś wykasuje to konto ?

Revision 1.15  2003/06/11 13:01:18  ankry
- added md5

Revision 1.14  2003/05/25 05:46:18  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.13  2003/04/28 06:25:34  trojan
- added patch (removed -D_LIBC)
NFY, TODO: fix errno bug

Revision 1.12  2002/10/28 21:38:26  filon
- updated to version 2.30, STBR

Revision 1.11  2002/09/07 09:02:18  kloczek
- merge translations from Conectiva.

Revision 1.10  2002/09/07 07:58:29  kloczek
- %%{_libdir}/clisp/full/lisp.run is back to %files.

Revision 1.9  2002/09/07 07:54:42  kloczek
- release 3: added using %%find_lang macro.

Revision 1.8  2002/06/15 11:41:09  ankry
- removed %%lang(en)
- release 2

Revision 1.7  2002/04/25 16:05:49  arturs
fixed a small typo

Revision 1.6  2002/04/07 08:14:16  filon
- updated to 2.28

Revision 1.5  2002/02/22 23:28:45  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.4  2002/02/06 23:11:43  filon
- added breq: ncurses-devel
- release 2

Revision 1.3  2002/01/18 02:12:34  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.2  2001/12/03 12:27:00  qboosh
- pl translations, cosmetics

Revision 1.1  2001/12/01 12:54:14  qrczak
- Initial version.
